package edu.mermet.tp8.dialog;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.TreeSelectionModel;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.actions.ActionSelection;

public class CommentFaire extends JDialog {
    private DefaultTreeModel arbre;

    public CommentFaire(Application appli) {
        super(appli, "Comment Faire ?");
        init();
        this.setSize(400, 300);
        this.setDefaultCloseOperation(HIDE_ON_CLOSE);
        //this.addWindowListener(new EcouteurCommentFaire(f.getActionCommentFaire()));
    }

    public void init() {
        JTree tree = new JTree();

        // Partie de droite
        JPanel panelG = new JPanel();
        panelG.setLayout(new BorderLayout()); 
        setContentPane(panelG);
        panelG.add(tree, BorderLayout.WEST);

        try (InputStream input = new FileInputStream("src/main/java/edu/mermet/tp8/HowTo/titres.properties")) {

            Properties prop = new Properties();

            prop.load(input);
            
            DefaultMutableTreeNode racine = new DefaultMutableTreeNode(prop.getProperty("racine"));
            arbre = new DefaultTreeModel(racine);
            DefaultMutableTreeNode noeudCourant, ancetre;
            ancetre = racine;
            noeudCourant = new DefaultMutableTreeNode(prop.getProperty("conversion"));
            ancetre.add(noeudCourant);
            ancetre = noeudCourant;
            noeudCourant = new DefaultMutableTreeNode(prop.getProperty("CelFar"));
            ancetre.add(noeudCourant);
            noeudCourant = new DefaultMutableTreeNode(prop.getProperty("FarCel"));
            ancetre.add(noeudCourant);
            ancetre = racine;
            noeudCourant = new DefaultMutableTreeNode(prop.getProperty("gras"));
            ancetre.add(noeudCourant);
            noeudCourant = new DefaultMutableTreeNode(prop.getProperty("couleur"));
            ancetre.add(noeudCourant);
            tree.setModel(arbre);

        } catch (IOException ex) {
            ex.printStackTrace();
        }

        // Partie de droite
        JPanel panelD = new JPanel();
        panelD.setLayout(new FlowLayout(FlowLayout.LEFT));
        JEditorPane html = new JEditorPane();
        html.setSize(200, 300);
        panelD.add(html, BorderLayout.WEST);
        add(panelD, BorderLayout.CENTER);

        TreeSelectionModel modeleSelection = new DefaultTreeSelectionModel();
        modeleSelection.setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        tree.setSelectionModel(modeleSelection); 
        tree.addTreeSelectionListener(new ActionSelection(html));

    }
}